proc fcmp outlib=sasuser.myfunc.UTC2LOCAL;
   function UTC2LOC(dt,z $);
      Z=UPCASE(Z);
      select (z);
         when ('NEWFOUNDLAND') ZONE=-3.5;
         when ('ATLANTIC') ZONE=-4;
         when ('EASTERN') ZONE=-5;
         when ('CENTRAL') ZONE=-6;
         when ('MOUNTAIN') ZONE=-7;
         when ('PACIFIC') ZONE=-8;
         when ('SASKATCHEWAN') ZONE=-6;
         when ('ARIZONA') ZONE=-7;
         when ('ALASKA') ZONE=-9;
         when ('HAWAII') ZONE=-11;
         otherwise do;
            zone=0;
            PUT 'Valid zones: NEWFOUNDLAND, ALLANTIC, EASTERN, CENTRAL, '
                'MOUNTAIN, PACIFIC, ALASKA, ARIZONA, HAWAII or SASKATCHEWAN.';
         end;
      end;
      year=year((datepart(dt)));
      day1=mdy(1,1,year);
      /* Year <=2006 DST starts 1st SUN in April, ends last SUN in October */
      if year <= 2006 then do;
         dst_month_start=intnx('month',day1,3);
         dst_beg=intnx('week.1',dst_month_start
                       ,(weekday(dst_month_start) ne 1));
         dst_month_end=intnx('month',day1,9);
         dst_end=intnx('week.1',dst_month_end
                       ,(weekday(dst_month_end) in (6,7))+4);
      end;
      /* Year >2006 DST starts 2nd SUN in March, ends 1st SUN in November. */
      else do;  
         dst_month_start=intnx('month',day1,2);
         dst_beg=intnx('week.1',dst_month_start
                       ,(weekday(dst_month_start) in (2,3,4,5,6,7))+1);
         dst_month_end=intnx('month',day1,10);
         dst_end=intnx('week.1',dst_month_end,(weekday(dst_month_end) ne 1));
      end;
      NEWDATE=dt+(zone*3600);
      if dst_beg<=datepart(dt)<=dst_end 
         and Z NOT IN ('ARIZONA','HAWAII','SASKATCHEWAN')
         then NEWDATE=NEWDATE+(3600);
      return(NEWDATE);
   endsub;
run;
